/**
 **	File ......... IWeb.cpp
 **	Published ....  2004-07-09
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#include <stdio.h>

#include "IWeb.h"
#include <libibank.h>

/*
#define DEB(x) { \
	FILE *fil = fopen("/tmp/debug","at"); \
	x; \
	fclose(fil); \
}
*/
#define DEB(x)

//extern char **environ;


IWeb::IWeb() : Web(COOKIE_DOMAIN, COOKIE_PATH)
,m_db("localhost","web","","ibank")
,m_bSetCookie(false)
,m_image(0)
,m_pImage(NULL)
,m_image_tn(false)
,m_not_modified(false)
//
,m_form1(this)
,m_form2(this)
,m_form3(this)
,m_form4(this)
,m_form5(this)
,m_form6(this)
,m_form7(this)
,m_form8(this)
//
,m_usernum(0)
,m_valid(0)
,m_forum(0)
,m_thread(0)
,m_page(0)
,m_index(0)
,m_qty(0)
,m_message(0)
{
	m_db.RegErrHandler(&m_log);

	RegWebForm(&m_form1);
	RegWebForm(&m_form2);
	RegWebForm(&m_form3);
	RegWebForm(&m_form4);
	RegWebForm(&m_form5);
	RegWebForm(&m_form6);
	RegWebForm(&m_form7);
	RegWebForm(&m_form8);
}


IWeb::~IWeb()
{
}


void IWeb::ReadCookies()
{
	char slask[1000];
	GetCookies() -> getvalue("ibc", slask, 1000);
	cgi::Parse pa(slask,":");
	m_usernum = pa.getvalue();
	m_valid = pa.getvalue();
	m_forum = pa.getvalue();
	m_thread = pa.getvalue();
	m_page = pa.getvalue();
	m_index = pa.getvalue();
	m_qty = pa.getvalue();
	m_message = pa.getvalue();
}


void IWeb::FormInput()
{
	std::string page = GetForm() -> getvalue("page");
	if (page.size())
	{
		SetPage(atoi(page.c_str()));
	}
	std::string img = GetForm() -> getvalue("img");
	if (img.size())
	{
		m_pImage = new db::Image(m_db, atol(img.c_str()));
		m_image = m_pImage -> num;
	}
	else
	{
		img = GetForm() -> getvalue("imgtn");
		if (img.size())
		{
			m_pImage = new db::Image(m_db, atol(img.c_str()));
			m_image = m_pImage -> num;
			m_image_tn = true;
		}
	}
	std::string logout = GetForm() -> getvalue("logout");
	if (logout.size() && atoi(logout.c_str()) == 1)
	{
		Query q(m_db);
		char sql[1000];
		sprintf(sql,"delete from valid where account=%ld and valid=%ld",m_usernum,m_valid);
		q.execute(sql);
	}
//printf("\n<html><body><h3>debug forminput</h3>");
	Web::FormInput();
}


void IWeb::CreateHeader()
{
	char *if_modified_since = getenv("HTTP_IF_MODIFIED_SINCE");
	// HTTP_IF_MODIFIED_SINCE=Tue, 06 Jul 2004 16:33:51 GMT

	if (m_image && if_modified_since && datetime2httpdate(m_pImage -> modified) == if_modified_since)
	{
		printf("Status: 304 Not Modified\n\n");
		m_not_modified = true;
		return;
	}
	if (m_bSetCookie)
	{
		SetTheCookie();
	}
	if (m_image)
	{
		// Last-Modified: Wed, 15 Nov 1995 04:58:08 GMT
		printf("Last-modified: %s\n",datetime2httpdate(m_pImage -> modified).c_str());
		printf("Content-type: %s\n",m_form1.GetMimeFromFilename(m_image_tn ? "/tmp/tn.gif" : m_pImage -> filename).c_str());
	}
	else
	{
		printf("Content-type: text/html\n");
	}
	// End of header
	printf("\n");
fflush(stdout);
}


void IWeb::GenerateDocument()
{
	db::Account account(GetDatabase(), m_usernum);
	char sql[1000];
	sprintf(sql,"select * from valid where account=%ld and valid=%ld",m_usernum,m_valid);
	db::Valid valid(&GetDatabase(), sql);
/*
	{
		size_t i = 0;
		while (environ[i])
		{
DEB(			fprintf(fil,"%s\n",environ[i]);)
			i++;
		}
	}
*/	
	if (!account.num || !valid.num)
	{
		SetPage( 1 );
	}
	else
	if (m_image && m_not_modified)
	{
		return;
	}
	else
	if (m_image)
	{
		cgi::Base64 bomb;
		bomb.decode_to_stdout(m_image_tn ? m_pImage -> image_tn : m_pImage -> image_data);
		return;
	}
	// HTML start
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n");
	printf("<html>\n");
	printf("<head>\n");
	printf("<link rel=\"STYLESHEET\" href=\"/style/ib.css\" type=\"text/css\">\n");
//	printf("<link rel=\"SHORTCUT ICON\" href=\"http://www.alhem.net/icon/flags/se.png\">\n");
	printf("<title>IBank :: The Image Vault</title>\n");
	printf("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\">\n");
//	printf("<SCRIPT language=\"JavaScript\" SRC=\"http://www.alhem.net/js/overlib_mini4.js\" type=\"text/javascript\"></SCRIPT>\n");

	printf("</head>\n");
	printf("<body>\n");
//	printf("<div id=\"overDiv\" style=\"position:absolute; visibility:hide; z-index:1;\"></div>\n");
if (0)
{
	char key[200];
	char val[200];
	printf("<h3>Form</h3>");
	GetForm() -> getfirst(key,200,val,200);
	while (*key)
	{
		printf("%s == '%s'<br>",key,val);
		printf("getvalue(%s) == '%s'<br>",key,GetForm() -> getvalue(key).c_str());
		GetForm() -> getnext(key,200,val,200);
	}
	printf("<h3>Cookies</h3>");
	printf("<b>Cookie value to set == '%s'</b><br>",m_cookie_to_set.c_str());
	for (cookie_v::iterator it = GetCookies() -> GetCookies().begin(); it !=
		GetCookies() -> GetCookies().end(); it++)
	{
		COOKIE *p = *it;
		printf("%s == '%s'<br>",p -> name,p -> value);
	}
	printf("<hr>");
}
	if (m_page > 1 && 0)
	{
		printf("<table width=\"100%%\"><tr><td><a href=\"http://www.alhem.net/\"><img border=0 src=\"/icons/ahl.png\"></a></td>");
		printf("<td>");
		printf("<center>\n");
		printf("<script type=\"text/javascript\" src=\"/js/goog.js\"></script>");
		printf("</center>\n");
		printf("</td>");
/*
		printf("<td align=right>");
		printf("<a href=\"http://www.bosrup.com/web/overlib/\">");
		printf("<img src=\"/image/power.gif\" width=\"88\" height=\"31\" alt=\"Popups by overLIB!\" border=\"0\"></a>");
		printf("</td>");
*/
		printf("</tr></table>");
	} // m_page > 2
fflush(stdout);

	switch (m_page)
	{
	case 1: // login / register
		m_form1.Display( 0 );
		break;
	case 2: // user settings
		m_form2.Display( m_usernum );
		break;
	case 3: // forums
		m_form3.Display( 0 );
		break;
	case 4: // threads
		m_form4.Display( m_forum );
		break;
	case 5: // view thread
		m_form5.Display( m_thread );
		break;
	case 6: // new thread
		m_form6.Display( m_forum );
		break;
	case 7: // new message
		m_form7.Display( m_thread );
		break;
	case 8: // edit message
		m_form8.Display( m_message );
		break;
	}
fflush(stdout);

	// Footer
	printf("</body>\n");
	printf("</html>\n");
fflush(stdout);
}


/*
cookie =
 <usernum> : <valid> : <forum> : <thread> : <page> : <index> : <qty>
*/
void IWeb::SetTheCookie()
{
	char slask[1000];
	sprintf(slask,"%ld:%ld:%ld:%ld:%ld:%ld:%ld:%ld",
		m_usernum,m_valid,m_forum,m_thread,m_page,m_index,m_qty,m_message);
	SetCookie("ibc", slask);
	m_cookie_to_set = slask;
}


