/**
 **	File ......... ViewThreadForm.cpp
 **	Published ....  2004-07-09
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#include <stdio.h>
#include <map>

#include "IWeb.h"
#include <libibank.h>
#include "ViewThreadForm.h"




ViewThreadForm::ViewThreadForm(Web *w) : BaseForm(w, "ViewThreadForm")
{
}


ViewThreadForm::~ViewThreadForm()
{
}


void ViewThreadForm::Process()
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
	Database& db = pWeb -> GetDatabase();
	char action[200];

	// <input type="submit" name="ViewThreadForm" value="action" ...
	if (!GetForm() -> getvalue( (char *)GetFormName().c_str(), action, 200) || !*action)
	{
		return;
	}
	if (!strcmp(action,"edit"))
	{
		std::string message = GetForm() -> getvalue("message");
		long num = atol(message.c_str());
		pWeb -> SetMessage(num);
		pWeb -> SetPage( 8 );
	}
	else
	if (!strcmp(action,"delete"))
	{
		db::Thread thread(db, pWeb -> GetThread());
		if (thread.started_by == pWeb -> GetUsernum())
		{
			thread.deleted++;
			thread.save();
		}
		pWeb -> SetPage( 4 );
	}
}


void ViewThreadForm::Display(long)
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
	Database& db = pWeb -> GetDatabase();
	Query q(db);
	Query q2(db);
	char sql[1000];
	std::map<long,long> mmap;
	db::Thread thread(db, pWeb -> GetThread());

//	printf("<h3>View thread</h3>");
	Navigator(pWeb -> GetForum(),pWeb -> GetThread());
	printf("</td><td align=center>");
	printf("[ <a href=\"%s?page=7\">post message</a> ",GetCgiName().c_str());
	if (thread.started_by == pWeb -> GetUsernum())
	{
		printf("| <a href=\"%s?ViewThreadForm=delete\">remove topic</a> ",GetCgiName().c_str());
	}
	printf("]</td><td align=right>");
//	printf("<div align=right>");
	printf("[ <a href=\"%s?page=2\">settings</a> ",GetCgiName().c_str());
	printf("| <a href=\"%s?logout=1\">logout</a> ",GetCgiName().c_str());
//	printf("]</div>");
	printf("]</td></tr></table>");
	printf("</div>");


	sprintf(sql,"select num,version from message where thread=%ld",pWeb -> GetThread());
	q.get_result(sql);
	while (q.fetch_row())
	{
		long num = q.getval();
		long version = q.getval();
		mmap[num] = (version > mmap[num]) ? version : mmap[num];
	}
	q.free_result();

	sprintf(sql,"select * from message where thread=%ld and deleted=0 order by posted",pWeb -> GetThread());
	q.get_result(sql);
	printf("<table cellpadding=\"0\" cellspacing=\"0\" class=viewthread width=\"100%%\">");
	while (q.fetch_row())
	{
		db::Message message(&db,&q);
		if (message.version == mmap[message.num])
		{
			db::Account account(db,message.posted_by);
			printf("<tr>");
			printf("<th class=viewthread width=\"1%%\" align=left>");
			printf("%s<br>",GetAccountName(account).c_str());
			nbprintf("%s",message.posted.c_str());
			if (message.version > 1)
			{
				printf("<br><span class=updated>Version: %d<br>",message.version);
				nbprintf("%s</span>",message.updated.c_str());
			}
			printf("</th>");
			printf("<td class=viewthread><b>%s</b>",message.title.c_str());
			if (message.posted_by == pWeb -> GetUsernum())
			{
				printf(" [ <a href=\"%s?ViewThreadForm=edit&message=%ld\">edit message</a> ]",GetCgiName().c_str(),message.num);
			}
			printf("<br>");
			viewtext(message.body);
			sprintf(sql,"select * from linkmessageimage where message=%ld and deleted=0",message.num);
			q2.get_result(sql);
			if (q2.num_rows() > 0)
			{
				printf("<hr>");
			}
			while (q2.fetch_row())
			{
				db::Linkmessageimage x(&db,&q2);
				printf("&nbsp;&nbsp;");
				viewtn( x.image );
//				printf("<a href=\"%s?img=%ld\">",GetCgiName().c_str(),x.image);
//				printf("<img alt=\"Thumbnail\" border=\"0\" src=\"%s?imgtn=%ld\"></a> ",GetCgiName().c_str(),x.image);
			}
			q2.free_result();
			printf("</tr>");
		}
	}
	printf("</table>");
	q.free_result();
}


